#include <iostream>
#include <cc++/config.h>
#include <cc++/macros.h>
#include <cc++/thread.h>

class MyThread : public Thread
{
public:
    ~MyThread();
private:
	void Run();
	void Final();
};

MyThread::~MyThread()
{
	Terminate();
	cout << "MyThread::~MyThread()" << endl;
};

void MyThread::Run()
{
	cout << "MyThreadRun()" << endl;
	Sleep(10000);
};

void MyThread::Final()
{
	cout <<"MyThreadFinal()" << endl;
};

int main()
{
	MyThread *thread = new MyThread();

	cout << "before start()..." << endl;

	thread->Detach();

	while(thread->isRunning()){
		sleep(1);
		cout << "thread is runnig." << endl;
	}

	thread->Detach();

	while(thread->isRunning()){
		sleep(1);
		cout << "thread is runnig again." << endl;
	}

	cout << "exiting..." << endl;

	delete thread;
}


